import cPickle as pickle
import MicroRNAClassification
import GistRunner
import Vienna
from PyML.classifiers.svm import loadSVM
import SnorreCutSetPredictor
from datetime import datetime
import math
import sys
from PyML import *
import MicroRNADetails
from pylab import *
import FeatureManagement
import MicroRNAStats
import PyMLManager
import MicroRNAProcessingSiteSVM as MPS
import MicroRNASVM as MS
import MicroRNADetails as MRD

CLASSIFICATOR_DIR = "/home/frederho/repo02/cgi-bin/precursor/data/"
CLASSIFICATOR_NAME = "FeatureVersion5.0_Sanger8.0_Algorithms7.0"

def RunMicroRNASVM2():
    verifiedPrecs = MPS.GetVerifiedPrecursors()
    failedPrecs = MPS.GetFalsePrecursors()

    failedMicroRNAVectors = GetFailedDecisionFunctions(verifiedPrecs, failedPrecs)
    #pickle.dump(failedMicroRNAVectors,open('failedMicroRNAVectors.p','wb'))

    verifiedMicroRNAVectors = GetVerifiedDecisionFunctions(verifiedPrecs)
    #pickle.dump(verifiedMicroRNAVectors,open('verifiedMicroRNAVectors.p','wb'))

    #verifiedMicroRNAVectors = pickle.load(open('verifiedMicroRNAVectors.p','rb'))
    #failedMicroRNAVectors = pickle.load(open('failedMicroRNAVectors.p','rb'))
    
    MS.TrainAndPredict(verifiedMicroRNAVectors + failedMicroRNAVectors, None)
    #featureTestResults = RunMicroRNAFeatureTest(verifiedMicroRNAVectors, failedMicroRNAVectors,1, 677)
    #pickle.dump(featureTestResults, open('newFeature14.p','wb'))
    #print "DONE14"
    #crash
    #hsaFolds = GetHSAFolds()
    #hsaPrecursorFolds = GetHSAPrecursorFolds(hsaFolds[0],hsaFolds[1])
    
    #remainingHSAPrecs = GetRemainingHSA(hsaFolds)
    #remainingHSAMicroRNAVectors = GetFailedDecisionFunctions(verifiedPrecs, remainingHSAPrecs)
    
    #trainingSet = [verifiedMicroRNAVectors, failedMicroRNAVectors]
    #results = Run10FoldMicroRNASVM(verifiedMicroRNAVectors, failedMicroRNAVectors)
    #pickle.dump(results, open('10foldrunResults.p','wv'))
    #posHSAMicroRNAVectors = GetPosHSA(verifiedPrecs, hsaPrecursorFolds[0])
    #pickle.dump(posHSAMicroRNAVectors, open('posHSAMicroRNAVectors.p','wb'))
    #negHSAMicroRNAVectors = GetNegHSA(verifiedPrecs, hsaPrecursorFolds[1])
    #pickle.dump(negHSAMicroRNAVectors, open('negHSAMicroRNAVectors.p','wb'))


    #posHSAMicroRNAVectors = pickle.load(open('posHSAMicroRNAVectors.p','rb'))
    #negHSAMicroRNAVectors = pickle.load(open('negHSAMicroRNAVectors.p','rb'))
    
    
    #hsaResults = RunHSACrossValidation(verifiedMicroRNAVectors, failedMicroRNAVectors, posHSAMicroRNAVectors, negHSAMicroRNAVectors, hsaFolds)
    #pickle.dump(hsaResults,open('hsaResultsnew.p','wb'))
    #print MS.ResultAnalysis(hsaResults[1])

def GetRemainingHSA(hsaFolds):
    precs = SnorreCutSetPredictor.GetPrecursorsFixedLength('hsa', 'all')
    remainingHSAPrecs = []
    HSA = []
    for fold in hsaFolds[0]:
        HSA.extend(fold)

    for fold in hsaFolds[1]:
        HSA.extend(fold)

    for prec in precs:
        if prec.id not in HSA:
            remainingHSAPrecs.append(prec)
    return remainingHSAPrecs

def RunMicroRNAFeatureTest(verifiedMicroRNAVectors, failedMicroRNAVectors, featureStart, featureLength):
    f = FeatureManagement.FeatureManagement()
    p = PyMLManager.PyMLManager()

    resultList = []
    resultDict = {}

    [verifiedVectorFolds, failedVectorFolds] = GetVectorFolds(verifiedMicroRNAVectors,failedMicroRNAVectors)

    for num in range(10):
        posTrainingSet = None
        negTrainingSet = None
        for i in range(len(verifiedVectorFolds)):
            if i != num:
                if posTrainingSet == None:
                    posTrainingSet = verifiedVectorFolds[i]
                else:
                    posTrainingSet = posTrainingSet + verifiedVectorFolds[i]
            if i != num:
                if negTrainingSet == None:
                    negTrainingSet = failedVectorFolds[i]
                else:
                    negTrainingSet = negTrainingSet + failedVectorFolds[i]
        posTrainingDict = p.MakeDict(posTrainingSet, '+1')
        negTrainingDict = p.MakeDict(negTrainingSet, '-1')
        values = None

        newPosTrainingDict = f.RemoveFeature(posTrainingDict, featureStart, featureLength)
        newNegTrainingDict = f.RemoveFeature(negTrainingDict, featureStart, featureLength)
        
        #Extra feature elimination
        startkey = 680
        numfeatures = 1
        for k in range(len(newPosTrainingDict)):
            for i in range(startkey, startkey+numfeatures):
                del newPosTrainingDict[k][i]
        for k in range(len(newNegTrainingDict)):
            for i in range(startkey, startkey+numfeatures):
                del newNegTrainingDict[k][i]

        
        p.WriteDictToFile(newPosTrainingDict, newNegTrainingDict)
        
        
        trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
        trainingData.normalize(2)
        
        posTestSet = verifiedVectorFolds[num]
        negTestSet = failedVectorFolds[num]            

        
        
        
        posTestDict = p.MakeDict(posTestSet, '+1')
        negTestDict = p.MakeDict(negTestSet, '-1')

        
        newPosTestDict = f.RemoveFeature(posTestDict, featureStart, featureLength)
        newNegTestDict = f.RemoveFeature(negTestDict, featureStart, featureLength)

        for k in range(len(newPosTestDict)):
            for i in range(startkey, startkey+numfeatures):
                del newPosTestDict[k][i]
        for k in range(len(newNegTestDict)):
            for i in range(startkey, startkey+numfeatures):
                del newNegTestDict[k][i]
        
        p.WriteTestDictToFile(posTestDict,negTestDict)

        testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
        testData.normalize(2)

        trainedSVM = p.PyMLTrain(trainingData)
        results = p.PyMLClassify(trainedSVM, trainingData, testData)
        decisionFunctions = results.getDecisionFunction()
        #results.plotROC()
        idMap = MS.IdMap(posTestSet, negTestSet, decisionFunctions)
        resultList.append(idMap)
        resultDict[num] = results

        print "==========================Fold " + str(num) + "====================================="
        print decisionFunctions
        print "===================================================================================="
        
    return [resultDict, resultList]

def RunHSACrossValidation(verifiedMicroRNAVectors, failedMicroRNAVectors, posHSAMicroRNAVectors, negHSAMicroRNAVectors, hsaFolds):
    f = FeatureManagement.FeatureManagement()
    p = PyMLManager.PyMLManager()

    resultList = []
    resultDict = {}

    [verifiedVectorFolds, failedVectorFolds] = GetVectorFolds(verifiedMicroRNAVectors,failedMicroRNAVectors)

    
    negHSAVectorFolds = [[] for i in range(len(hsaFolds[1]))]
    posHSAVectorFolds = [[] for i in range(len(hsaFolds[0]))]
    
    total1 = 0
    total2 = 0
    
    for num in range(len(hsaFolds[0])):
        for i in range(len(posHSAMicroRNAVectors)):
            temp = posHSAMicroRNAVectors[i][0]
            if temp[temp.index('@')+1:temp.index('#')] in hsaFolds[0][num]:
                posHSAVectorFolds[num].append(posHSAMicroRNAVectors[i])

    for num in range(len(hsaFolds[1])):
        for i in range(len(negHSAMicroRNAVectors)):
            temp = negHSAMicroRNAVectors[i][0]
            if temp[temp.index('@')+1:temp.index('#')] in hsaFolds[1][num]:
                negHSAVectorFolds[num].append(negHSAMicroRNAVectors[i])
    
                            
    for num in range(10):
        posTrainingSet = None
        negTrainingSet = None
        for i in range(len(verifiedVectorFolds)):
            if i != num:
                if posTrainingSet == None:
                    posTrainingSet = verifiedVectorFolds[i]
                else:
                    posTrainingSet = posTrainingSet + verifiedVectorFolds[i]
            if i != num:
                if negTrainingSet == None:
                    negTrainingSet = failedVectorFolds[i]
                else:
                    negTrainingSet = negTrainingSet + failedVectorFolds[i]
        
        posTrainingDict = p.MakeDict(posTrainingSet, '+1')
        negTrainingDict = p.MakeDict(negTrainingSet, '-1')

        featureStart = 1
        featureLength = 677
        
        newPosTrainingDict = f.RemoveFeature(posTrainingDict, featureStart, featureLength)
        newNegTrainingDict = f.RemoveFeature(negTrainingDict, featureStart, featureLength)
        

        
        p.WriteDictToFile(newPosTrainingDict, newNegTrainingDict)
        
        posTestSet = posHSAVectorFolds[num]
        negTestSet = negHSAVectorFolds[num]            
        
        trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
        trainingData.normalize(2)
        
        posTestDict = p.MakeDict(posTestSet, '+1')
        negTestDict = p.MakeDict(negTestSet, '-1')

        newPosTestDict = f.RemoveFeature(posTestDict, featureStart, featureLength)
        newNegTestDict = f.RemoveFeature(negTestDict, featureStart, featureLength)

        p.WriteTestDictToFile(newPosTestDict,newNegTestDict)

        testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
        testData.normalize(2)

        trainedSVM = p.PyMLTrain(trainingData)
        results = p.PyMLClassify(trainedSVM, trainingData, testData)
        decisionFunctions = results.getDecisionFunction()
        #results.plotROC()
        idMap = MS.IdMap(posTestSet, negTestSet, decisionFunctions)
        resultList.append(idMap)
        resultDict[num] = results

        print "==========================Fold " + str(num) + "====================================="
        print decisionFunctions
        print "===================================================================================="
        
    return [resultDict, resultList]
    
def GetHSAFolds():

    verifiedMicroRNAVectors = pickle.load(open('verifiedMicroRNAVectors.p','rb'))
    failedMicroRNAVectors = pickle.load(open('failedMicroRNAVectors.p','rb'))

    folds = GetVectorFolds(verifiedMicroRNAVectors, failedMicroRNAVectors)
    verifiedFoldID = []
    for fold in folds[0]:
        temp = [vector[0] for vector in fold]
        temp2 = [temp1[temp1.index('@')+1:temp1.index('#')] for temp1 in temp]
        verifiedFoldID.append(temp2)
    verifiedIDFolds = []

    for fold in verifiedFoldID:
        newID = [MRD.GetIdFromName(name) for name in fold]
        verifiedIDFolds.append(newID)
    
    failedFoldID = []
    for fold in folds[1]:
        temp = [vector[0] for vector in fold]
        temp2 = [temp1[temp1.index('@')+1:temp1.index('#')] for temp1 in temp]
        failedFoldID.append(temp2)

    failedIDFolds = []
    for fold in failedFoldID:
            newID = [MRD.GetIdFromName(name) for name in fold]
            failedIDFolds.append(newID)
            
    families = MRD.GetFamilies('mmu')
    mmuFamilies = families['famid2id']
    allFamilies = MRD.GetFamilies()
    allFamilies = allFamilies['famid2id']
    posFamilyFolds = []
    for i in range(len(verifiedIDFolds)):
        postemp = []
        for key in mmuFamilies.keys():
            S1 = set(verifiedIDFolds[i])
            S2 = set(mmuFamilies[key])
            if S1.intersection(S2):
                postemp.append(key)
        posFamilyFolds.append(postemp)

    negFamilyFolds = []
    for i in range(len(failedIDFolds)):
        temp = []
        for key in mmuFamilies.keys():
            S1 = set(failedIDFolds[i])
            S2 = set(mmuFamilies[key])
            if S1.intersection(S2):
                temp.append(key)
        negFamilyFolds.append(temp)

    posHSAFolds = []
    for fold in posFamilyFolds:
        hsaTemp = []
        for family in fold:
            temp = allFamilies[family]
            for ID in temp:
                if 'hsa' in MRD.GetNameFromId(ID):
                    hsaTemp.append(MRD.GetNameFromId(ID))
        posHSAFolds.append(hsaTemp)
    
    negHSAFolds = []
    for fold in negFamilyFolds:
        hsaTemp = []
        for family in fold:
            temp = allFamilies[family]
            for ID in temp:
                if 'hsa' in MRD.GetNameFromId(ID):
                    hsaTemp.append(MRD.GetNameFromId(ID))
        negHSAFolds.append(hsaTemp)
    
    return [posHSAFolds, negHSAFolds]

def GetHSAPrecursorFolds(posHSAFold, negHSAFold):
    precs = SnorreCutSetPredictor.GetPrecursorsFixedLength('hsa', 'all')

    posHSAPrecFolds = []
    for fold in posHSAFold:
        posTemp = []
        for prec in precs:
            if prec.id in fold:
                posTemp.append(prec)
        posHSAPrecFolds.append(posTemp)

    negHSAPrecFolds = []
    counter = 0
    for fold in negHSAFold:
        negTemp = []
        for prec in precs:
            if prec.id in fold:
                counter += 1
                negTemp.append(prec)
        negHSAPrecFolds.append(negTemp)
    return [posHSAPrecFolds, negHSAPrecFolds]

def GetNegHSA(verifiedPrecs, negHSAPrecs):
    noFoldNegHSAPrecs = []
    counter = 0
    for fold in negHSAPrecs:
        noFoldNegHSAPrecs.extend(fold)

    
    microRNAVectors = GetFailedDecisionFunctions(verifiedPrecs, noFoldNegHSAPrecs)

    return microRNAVectors

def GetPosHSA(verifiedPrecs, posHSAPrecs):
    #Import supporting classes
    f = FeatureManagement.FeatureManagement()
    s = MicroRNAStats.MicroRNAStatistics()
    p = PyMLManager.PyMLManager()

    #initiating result objects
    resultDict = {}
    resultlist = []

    #getting family in same fold to avoid bias
    tenFold = GistRunner.TenFold()
    folds = GistRunner.TenFold.Get10FoldWithFamilyInSameFold(tenFold,verifiedPrecs)

    #Initiating the 10 fold cross validation
    for num in range(len(folds)):
        trainingSet = None
        testSet = None
        #creating trainingSet
        for i in range(len(folds)):
            if i != num:
                if trainingSet == None:
                    trainingSet = folds[i]
                else:
                    trainingSet = trainingSet + folds[i]

        testSet = posHSAPrecs[num]

        #Getting Vectors
        [posVec, negVec] = p.GetFeaturesAndLables(trainingSet)

        #Scaling down feature values
        values = None
        [posVec, negVec, values] = f.FeatureScaling(posVec, negVec, values)

        pos = p.MakeDict(posVec, '+1')
        neg = p.MakeDict(negVec, '-1')
        p.WriteDictToFile(pos,neg)

        #Loading trainingSet into PyML container
        trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
        trainingData.normalize(2)

        #change this to include labels so we can use the built in ROC score calculations
        [posTest, negTest] = p.GetFeaturesAndLables(testSet)
        [posTest, negTest, values] = f.FeatureScaling(posTest, negTest, values)
        
        pos = p.MakeDict(posTest, '+1')
        neg = p.MakeDict(negTest, '-1')

        p.WriteTestDictToFile(pos, neg)

        testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
        testData.normalize(2)

        #Running PyMLTrain on the trainingSet
        trainedSVM = p.PyMLTrain(trainingData)
        results = p.PyMLClassify(trainedSVM, trainingData, testData)
        decisionFunctions = results.getDecisionFunction()
        idMap = MS.IdMap(posTest, negTest, decisionFunctions)

        #results.plotROC()
        
        resultlist.append(idMap)
        resultDict[num] = results

    
    #cutsites = s.GetCutSites(resultlist)
    #statistics = s.Statistics(resultlist,cutsites)
    [ResultDictionary, posHSAMicroRNAVectors] = MS.CreateMicroRNADictionary(resultlist)
    return posHSAMicroRNAVectors


def Run10FoldMicroRNASVM(verifiedMicroRNAVectors, failedMicroRNAVectors):
    f = FeatureManagement.FeatureManagement()
    p = PyMLManager.PyMLManager()

    resultList = []
    resultDict = {}

    [verifiedVectorFolds, failedVectorFolds] = GetVectorFolds(verifiedMicroRNAVectors,failedMicroRNAVectors)

    for num in range(10):
        posTrainingSet = None
        negTrainingSet = None
        for i in range(len(verifiedVectorFolds)):
            if i != num:
                if posTrainingSet == None:
                    posTrainingSet = verifiedVectorFolds[i]
                else:
                    posTrainingSet = posTrainingSet + verifiedVectorFolds[i]
            if i != num:
                if negTrainingSet == None:
                    negTrainingSet = failedVectorFolds[i]
                else:
                    negTrainingSet = negTrainingSet + failedVectorFolds[i]
        
        posTrainingDict = p.MakeDict(posTrainingSet, '+1')
        negTrainingDict = p.MakeDict(negTrainingSet, '-1')
        p.WriteDictToFile(posTrainingDict, negTrainingDict)

        posTestSet = verifiedVectorFolds[num]
        negTestSet = failedVectorFolds[num]            
        
        trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
        trainingData.normalize(2)
        
        posTestDict = p.MakeDict(posTestSet, '+1')
        negTestDict = p.MakeDict(negTestSet, '-1')
        p.WriteTestDictToFile(posTestDict,negTestDict)

        testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
        testData.normalize(2)

        trainedSVM = p.PyMLTrain(trainingData)
        results = p.PyMLClassify(trainedSVM, trainingData, testData)
        decisionFunctions = results.getDecisionFunction()
        #results.plotROC()
        idMap = MS.IdMap(posTestSet, negTestSet, decisionFunctions)
        resultList.append(idMap)
        resultDict[num] = results

        print "==========================Fold " + str(num) + "====================================="
        print decisionFunctions
        print "===================================================================================="
        
    return [resultDict, resultList]

def GetVectorFolds(pos, neg):
    	verified = MPS.GetVerifiedPrecursors()
	failed = MPS.GetFalsePrecursors()

	tenFold = GistRunner.TenFold()
	verifiedFolds = GistRunner.TenFold.Get10FoldWithFamilyInSameFold(tenFold,verified)
	failedFolds = GistRunner.TenFold.Get10FoldWithFamilyInSameFold(tenFold,failed)

	verifiedFoldID = []
	failedFoldID = []

	for num in range(len(verifiedFolds)):
		verifiedFoldID.append([prec.id for prec in verifiedFolds[num]])

	
	for num in range(len(failedFolds)):
		failedFoldID.append([prec.id for prec in failedFolds[num]])

	failedVectorFolds = [[] for i in range(len(verifiedFoldID))]
	verifiedVectorFolds = [[] for i in range(len(failedFoldID))]

        total1 = 0

	total2 = 0
	for num in range(len(verifiedFoldID)):
            for i in range(len(pos)):
                temp = pos[i][0]
                if temp[temp.index('@')+1:temp.index('#')] in verifiedFoldID[num]:
                    verifiedVectorFolds[num].append(pos[i])
                    total1 += 1
                    
        for num in range(len(failedFoldID)):
            for i in range(len(neg)):
                temp = neg[i][0]
                if temp[temp.index('@')+1:temp.index('#')] in failedFoldID[num]:
                    failedVectorFolds[num].append(neg[i])
                    total2 += 1

        return [verifiedVectorFolds, failedVectorFolds]
    
def GetVerifiedDecisionFunctions(precs):
    #Import supporting classes
    f = FeatureManagement.FeatureManagement()
    s = MicroRNAStats.MicroRNAStatistics()
    p = PyMLManager.PyMLManager()

    #initiating result objects
    resultDict = {}
    resultlist = []

    #getting family in same fold to avoid bias
    tenFold = GistRunner.TenFold()
    folds = GistRunner.TenFold.Get10FoldWithFamilyInSameFold(tenFold,precs)

    #Initiating the 10 fold cross validation
    for num in range(len(folds)):
        trainingSet = None
        testSet = None
        #creating trainingSet
        for i in range(len(folds)):
            if i != num:
                if trainingSet == None:
                    trainingSet = folds[i]
                else:
                    trainingSet = trainingSet + folds[i]

        testSet = folds[num]

        #Getting Vectors
        [posVec, negVec] = p.GetFeaturesAndLables(trainingSet)

        #Scaling down feature values
        values = None
        [posVec, negVec, values] = f.FeatureScaling(posVec, negVec, values)

        pos = p.MakeDict(posVec, '+1')
        neg = p.MakeDict(negVec, '-1')
        p.WriteDictToFile(pos,neg)

        #Loading trainingSet into PyML container
        trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
        trainingData.normalize(2)

        #change this to include labels so we can use the built in ROC score calculations
        [posTest, negTest] = p.GetFeaturesAndLables(testSet)
        [posTest, negTest, values] = f.FeatureScaling(posTest, negTest, values)
        
        pos = p.MakeDict(posTest, '+1')
        neg = p.MakeDict(negTest, '-1')

        p.WriteTestDictToFile(pos, neg)

        testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
        testData.normalize(2)

        #Running PyMLTrain on the trainingSet
        trainedSVM = p.PyMLTrain(trainingData)
        results = p.PyMLClassify(trainedSVM, trainingData, testData)
        decisionFunctions = results.getDecisionFunction()
        idMap = MS.IdMap(posTest, negTest, decisionFunctions)

        #results.plotROC()
        
        resultlist.append(idMap)
        resultDict[num] = results

    
    #cutsites = s.GetCutSites(resultlist)
    #statistics = s.Statistics(resultlist,cutsites)
    pickle.dump(resultlist,open('mmuMPSResultList.p','wb'))
    crash
    [ResultDictionary, VerifiedMicroRNAVectors] = MS.CreateMicroRNADictionary(resultlist)
    return VerifiedMicroRNAVectors

def GetFailedDecisionFunctions(trainingSet, testSet):
    f = FeatureManagement.FeatureManagement()
    s = MicroRNAStats.MicroRNAStatistics()
    p = PyMLManager.PyMLManager()

    resultlist = []
    resultDict = {}

    [posVec, negVec] = p.GetFeaturesAndLables(trainingSet)
    #Scaling down feature values
    values = None
    [posVec, negVec, values] = f.FeatureScaling(posVec, negVec, values)
    
    pos = p.MakeDict(posVec, '+1')
    neg = p.MakeDict(negVec, '-1')
    p.WriteDictToFile(pos,neg)
    
    #Loading trainingSet into PyML container
    trainingData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtrainingData.data')
    trainingData.normalize(2)
    
    #change this to include labels so we can use the built in ROC score calculations
    [posTest, negTest] = p.GetFeaturesAndLables(testSet)
    [posTest, negTest, values] = f.FeatureScaling(posTest, negTest, values)


    pos = p.MakeDict(posTest, '+1')
    neg = p.MakeDict(negTest, '-1')
    
    p.WriteTestDictToFile(pos, neg)
    
    testData = SparseDataSet(CLASSIFICATOR_DIR + 'PyMLtestData.data')
    testData.normalize(2)
    
    #Running PyMLTrain on the trainingSet
    trainedSVM = p.PyMLTrain(trainingData)
    results = p.PyMLClassify(trainedSVM, trainingData, testData)
    decisionFunctions = results.getDecisionFunction()
    #results.plotROC()
    idMap = MS.IdMap(posTest, negTest, decisionFunctions)

    resultlist.append(idMap)

    #cutsites = s.GetCutSites(resultlist)
    #statistics = s.Statistics(resultlist,cutsites)
    [ResultDictionary, failedMicroRNAVectors] = MS.CreateMicroRNADictionary(resultlist)
    #print ResultDictionary
    return failedMicroRNAVectors
    
def main():
    param = sys.argv

    if len(param)>1 and param[0] == "MicroRNASVM2.py":
        if param[1] == "SVM":
            RunMicroRNASVM2()

if __name__ == "__main__":
    main()



