from pylab import *
import numpy.numarray as na
CLASSIFICATOR_DIR = "/home/frederho/repo02/cgi-bin/precursor/data/"
class MicroRNAStatistics:
    #Statistics calculates tp fp, number of better, distance from true site to best site and more
    def Statistics(self, resultlist,cutsites):
	cuts = None
	idMap = None
	truepositive = 0
	falsepositive = 0
	distancemap = {0:0,1:0,2:0,3:0,4:0,5:0,6:0,7:0,8:0,9:0,10:0,11:0,12:0,13:0,14:0, 15:0, 16:0, 17:0, 18:0}
        numberOfBetter = {0:0,1:0,2:0,3:0,4:0,5:0,6:0,7:0,8:0,9:0,10:0,11:0,12:0,13:0,14:0, 15:0, 16:0, 17:0, 18:0}
	#En container med statistikk for alle miRNA i crossvalidation
	statistics = {}
	position = []
	decisiondict = {}
	correctPredictions = []
	bestPredictions = []
	for i in range(len(resultlist)):
		cuts = cutsites[i]
		idMap = resultlist[i]
		for key in cuts.keys():
			tp = True
			real = best = -999
			realpos = bestpos = -1
			distance = 0
			numberofbetter = 0
			sites = cuts[key]
			real = idMap[sites[0]][3]
			realpos = idMap[sites[0]][1]
			decisionFunction = []
			temp = []
			for score in sites:
				decisionFunction.append(idMap[score][3])
				temp.append(score)
				if idMap[score][3] > real:
					numberofbetter = numberofbetter + 1
					tp = False
			


			best = max(decisionFunction)

			bestpos = idMap[temp[decisionFunction.index(best)]][1]
			
			if tp:
				best = idMap[sites[0]][3]
				bestpos = idMap[sites[0]][1]
				truepositive = truepositive + 1
			else:
				falsepositive = falsepositive + 1
                        
			distance = MicroRNAStatistics().GetDistance(bestpos,realpos)
			distancemap[distance] = distancemap[distance] + 1
			statistics[key] = [real,realpos,best,bestpos, distance, numberofbetter]
			position.append([realpos,bestpos])
			decisiondict[key] = decisionFunction
			numberOfBetter[numberofbetter] = numberOfBetter[numberofbetter] + 1
			
			if distance == 0:
				correctPredictions.append(key+'#'+realpos)
			else:
				bestPredictions.append(key+'#'+bestpos)
			
	print "==================================================================================="
	print distancemap
	print "==================================================================================="

	#This section is used to create the bar graph
        
	labels = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
	result = [distancemap[x] for x in range(15)]

	xlocations = na.array(range(len(result)))+0.5
	width = 0.5
	bar(xlocations, result, width=width)
	xticks(xlocations+ width/2, labels)
	xlim(0, xlocations[-1]+width*2)
	title("Number of miRNAs within given distance from true site")
	gca().get_yaxis().tick_left()

	show()
        
	
	"""
	f = open('correctPredictions.data','w')
	for element in correctPredictions:
		f.write(element)
		f.write('\n')
	f.close()

	f = open('bestPredictions.data','w')
	for element in bestPredictions:
		f.write(element)
		f.write('\n')
	f.close()
	"""

	print position
	f = open(CLASSIFICATOR_DIR +'decisionFunction.data','w')
	for key in decisiondict.keys():
		f.write(key)
		f.write(str(decisiondict[key]))
		f.write('\n\n')
	f.close()

	return statistics

    #Returns the number of vectors between the highest scoring cut and the true cut.
    def GetDistance(self, bestpos, realpos):
        [best1,best2] = bestpos.split(',')
	[real1,real2] = realpos.split(',')
	best1 = int(best1)
	real1 = int(real1)
	if best1>real1:
		return best1-real1
	else:
		return real1-best1
	
        #finner posisjonen til de forskjellige cutsitene i idMap	
    def GetCutSites(self, resultlist):
	cutSiteList = []
	for idMap in resultlist:
		i = 0
		temp = []
		cutsites = {}
		for j in range(len(idMap)): temp.append(idMap[j][0])
		while idMap[i][2] == 1:
			indices = [k for k, x in enumerate(temp) if temp[k] == idMap[i][0]]
			cutsites[idMap[i][0]] = indices
			i = i + 1
		cutSiteList.append(cutsites)
	return cutSiteList
	
    def CreateMicroRNADictionary(self, resultlist):
        microRNADictionary = {}
        for idMap in resultlist:
            i = 0
            temp = []
            cutsites = {}
            for j in range(len(idMap)): temp.append(idMap[j][0])
            while idMap[i][2] == 1:
                indices = [k for k, x in enumerate(temp) if temp[k] == idMap[i][0]]
                decision = [[idMap[indices[n]][1],idMap[indices[n]][3]] for n in range(len(indices))]
                
                
                i = i + 1
                decisionfunction = []
                for k in range(len(decision)):
                    decisionfunction.append(decision[i][1])
                best = max(decisionfunction)
                bestmir = idMap[indices[decisionfunction.index(best)]][4]
                avg = sum(decisionfunction)/len(decisionfunction)
                microRNADictionary[idMap[i][0]] = [decision,best,bestmir,avg]
        print microRNADictionary
        return microRNADictionary
    
    #Returns the highest scoring decision fucntion for a given MicroRNA	
    def GetBestCut(self, predicted):
	bestcut = []
	bestcutscore = -999.0
	for cut in predicted:
	
		result = cut
	
		if cut[1] >bestcutscore:
			bestcutscore = cut[1]
			bestcut = cut[0]
		result = [bestcut,bestcutscore]
	return result
		

    def GetPredictions(self, results, vectors):
	stringid = []
	predicted = []
	decisionfunction = results.getDecisionFunction()

	for i in range(len(vectors)):
		temp = vectors[i][0][vectors[i][0].rfind('#')+1:]
		temp = temp.split(',')
		stringid.append([int(temp[0]),int(temp[1])])
	
	for i in range(len(decisionfunction)-1 ):
		predicted.append([stringid[i],decisionfunction[i]])

	return predicted
